/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 2L)
        return -1;
      return 0;

    case 1L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern3 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != MEM
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern30 (x2); /* [-1, 1] */
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || pattern34 (x1, 
E_DImode, 
-1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != IF_THEN_ELSE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x6, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XEXP (x6, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XEXP (x1, 0);
  operands[0] = x11;
  if (!gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x12 = XEXP (x3, 0);
  operands[1] = x12;
  if (!cc_reg_operand (operands[1], i1))
    return -1;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  return pattern59 (x3); /* [-1, 23] */
}

int
pattern65 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || !small_toc_ref (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !small_toc_ref (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2DFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT
      || GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_DFmode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x4, 1);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_DFmode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!vfloat_operand (operands[0], E_V2DFmode)
      || pattern79 (x1) != 0)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern101 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern103 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XVECEXP (x4, 0, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[3] = x10;
  x11 = XEXP (x6, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern103 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern103 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern103 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!reg_or_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!scratch_operand (operands[0], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case E_HImode:
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_DImode:
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          res = pattern167 ();
          if (res >= 0)
            return res + 2; /* [2, 4] */
          return -1;

        default:
          return -1;
        }

    case SET:
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x10) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x10) != E_DImode)
            return -1;
          res = pattern167 ();
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern193 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern192 (x1, 
i1); /* [-1, 3] */
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern229 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern233 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[2] = x2;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern181 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern181 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern228 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern228 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern228 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern228 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern228 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern228 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern228 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern228 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern228 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern228 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern230 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern230 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern232 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern232 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern232 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern232 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern232 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern232 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern232 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern232 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern232 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern232 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern269 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern282 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  if (!gpc_reg_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != E_SImode
      || !gpc_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern299 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[1], E_IFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_SImode)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern329 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case EQ:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case NE:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern344 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !non_add_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern356 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_or_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vlogical_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern373 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern375 (x5, 
i1); /* [-1, 0] */
}

int
pattern387 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern385 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern385 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern386 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern386 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern386 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern386 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern386 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern386 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern386 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern386 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern386 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern386 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern402 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern400 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern400 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern401 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern401 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern401 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern401 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern401 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern401 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern401 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern401 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern401 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern401 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern423 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern430 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern435 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_zero_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[4], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[4], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern445 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern444 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_DImode:
      if (pattern444 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern458 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!scratch_operand (operands[4], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DFmode
          || !gpc_reg_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DImode
          || !gpc_reg_operand (operands[1], E_V2DImode))
        return -1;
      return 1;

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_QImode
          || !gpc_reg_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_HImode
          || !gpc_reg_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SImode
          || !gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern491 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      return 0;

    case E_V2DFmode:
      return 1;

    case E_V4SImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V16QImode:
      return 4;

    case E_V2DImode:
      return 5;

    case E_V1TImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern505 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern512 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_reg_operand (operands[1], E_XOmode)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !vsx_register_operand (operands[3], E_V16QImode)
      || !const_0_to_15_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !d_form_memory (operands[1], i1)
      || !int_reg_operand (operands[2], E_DImode)
      || !scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern523 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern531 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern530 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern530 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern544 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[3]))
    return -1;
  return 0;
}

int
pattern553 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern562 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x5, 0);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  x15 = XEXP (x6, 0);
  operands[2] = x15;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x16 = XEXP (x10, 0);
  x17 = XEXP (x16, 0);
  if (!rtx_equal_p (x17, operands[1]))
    return -1;
  x18 = XEXP (x11, 0);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern463 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 346; /* *isel_reversed_cc_si */

        case 1:
          if (!
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 348; /* *isel_reversed_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern463 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 347; /* *isel_reversed_cc_di */

        case 1:
          if (!(
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 349; /* *isel_reversed_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  operands[4] = x6;
  x7 = XEXP (x3, 2);
  operands[5] = x7;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern480 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 370; /* *movsfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 372; /* *movsfdfcc_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern480 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 371; /* *movdfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 373; /* *movdfdfcc_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern481 (x3, 
E_KFmode) != 0
              || !(
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 382; /* *movkfcc_p10 */

        case E_TFmode:
          if (pattern481 (x3, 
E_TFmode) != 0
              || !(
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 383; /* *movtfcc_p10 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      if (!all_ones_constant (operands[4], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !zero_constant (operands[5], E_V2DImode))
        return -1;
      if (vsx_register_operand (operands[0], E_V2DImode))
        {
          switch (pattern479 ())
            {
            case 0:
              if (
#line 5732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 378; /* *fpmasksf */
              break;

            case 1:
              if (
#line 5732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 379; /* *fpmaskdf */
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[2], E_KFmode)
              || !altivec_register_operand (operands[3], E_KFmode)
              || !(
#line 5837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 386; /* *fpmaskkf */

        case E_TFmode:
          if (!altivec_register_operand (operands[2], E_TFmode)
              || !altivec_register_operand (operands[3], E_TFmode)
              || !(
#line 5837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 387; /* *fpmasktf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x4;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x10 = XEXP (x5, 0);
      operands[5] = x10;
      x11 = XEXP (x5, 1);
      operands[6] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern534 (x2, 
E_SImode) != 0
              || !
#line 4281 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
            return -1;
          return 245; /* *rotlsi3_insert */

        case E_DImode:
          if (pattern534 (x2, 
E_DImode) != 0
              || !(
#line 4281 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 246; /* *rotldi3_insert */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 1);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              switch (GET_CODE (x10))
                {
                case ASHIFT:
                case ROTATE:
                case LSHIFTRT:
                  operands[4] = x10;
                  operands[5] = x4;
                  operands[6] = x9;
                  x12 = XEXP (x10, 0);
                  operands[1] = x12;
                  x13 = XEXP (x10, 1);
                  operands[2] = x13;
                  if (!const_int_operand (operands[2], E_SImode))
                    return -1;
                  x11 = XEXP (x5, 1);
                  operands[3] = x11;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern541 (x2, 
E_SImode) != 0
                          || !
#line 4299 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
                        return -1;
                      return 247; /* *rotlsi3_insert_2 */

                    case E_DImode:
                      if (pattern541 (x2, 
E_DImode) != 0
                          || !(
#line 4299 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 248; /* *rotldi3_insert_2 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (!gpc_reg_operand (operands[0], E_SImode)
                          || GET_MODE (x2) != E_SImode
                          || GET_MODE (x3) != E_SImode)
                        return -1;
                      operands[1] = x4;
                      if (!gpc_reg_operand (operands[1], E_SImode))
                        return -1;
                      operands[2] = x9;
                      if (!const_int_operand (operands[2], E_SImode)
                          || GET_MODE (x5) != E_SImode)
                        return -1;
                      operands[3] = x10;
                      if (!gpc_reg_operand (operands[3], E_SImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[4] = x11;
                      if (!const_int_operand (operands[4], E_SImode)
                          || !
#line 4375 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)
   && UINTVAL (operands[2]) != 0 && UINTVAL (operands[4]) != 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 256; /* *rotlsi3_insert_5 */

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x2) != E_DImode
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (x4, E_DImode)
                          || !const_int_operand (x9, E_DImode))
                        return -1;
                      operands[2] = x9;
                      operands[1] = x4;
                      if (GET_MODE (x5) == E_DImode)
                        {
                          operands[3] = x10;
                          if (gpc_reg_operand (operands[3], E_DImode))
                            {
                              x11 = XEXP (x5, 1);
                              operands[4] = x11;
                              if (const_int_operand (operands[4], E_DImode)
                                  && 
#line 4389 "../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                                return 257; /* *rotldi3_insert_6 */
                            }
                        }
                      operands[4] = x9;
                      operands[3] = x4;
                      if (GET_MODE (x5) != E_DImode)
                        return -1;
                      operands[1] = x10;
                      if (!gpc_reg_operand (operands[1], E_DImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[2] = x11;
                      if (!const_int_operand (operands[2], E_DImode)
                          || !
#line 4404 "../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 258; /* *rotldi3_insert_7 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern209 (x2))
                {
                case 0:
                  if (!
#line 4313 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
                    return -1;
                  return 249; /* rotlsi3_insert_3 */

                case 1:
                  if (!(
#line 4313 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 250; /* rotldi3_insert_3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (GET_MODE (x5) != E_SImode
                  || !gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              operands[3] = x4;
              if (!gpc_reg_operand (operands[3], E_SImode))
                return -1;
              operands[4] = x9;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x5, 0);
              operands[1] = x10;
              if (!gpc_reg_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 4365 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) + exact_log2 (-UINTVAL (operands[4])) == 32))
                return -1;
              return 255; /* *rotlsi3_insert_4 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              if (GET_CODE (x10) != NOT)
                return -1;
              x6 = XEXP (x1, 0);
              operands[0] = x6;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern464 (x2, 
E_V4SImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_V4SImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1775; /* altivec_vselv4si3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_V4SImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return -1;
                  return 1785; /* altivec_vselv4si4 */

                case E_V8HImode:
                  if (pattern464 (x2, 
E_V8HImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_V8HImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1776; /* altivec_vselv8hi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_V8HImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return -1;
                  return 1786; /* altivec_vselv8hi4 */

                case E_V16QImode:
                  if (pattern464 (x2, 
E_V16QImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_V16QImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1777; /* altivec_vselv16qi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_V16QImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return -1;
                  return 1787; /* altivec_vselv16qi4 */

                case E_V4SFmode:
                  if (pattern464 (x2, 
E_V4SFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_V4SFmode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1778; /* altivec_vselv4sf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_V4SFmode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return -1;
                  return 1788; /* altivec_vselv4sf4 */

                case E_V2DFmode:
                  if (pattern464 (x2, 
E_V2DFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_V2DFmode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1779; /* altivec_vselv2df3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_V2DFmode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return -1;
                  return 1789; /* altivec_vselv2df4 */

                case E_V2DImode:
                  if (pattern464 (x2, 
E_V2DImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_V2DImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1780; /* altivec_vselv2di3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_V2DImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return -1;
                  return 1790; /* altivec_vselv2di4 */

                case E_V1TImode:
                  if (pattern464 (x2, 
E_V1TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_V1TImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1781; /* altivec_vselv1ti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_V1TImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return -1;
                  return 1791; /* altivec_vselv1ti4 */

                case E_TImode:
                  if (pattern464 (x2, 
E_TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_TImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1782; /* altivec_vselti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_TImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return -1;
                  return 1792; /* altivec_vselti4 */

                case E_KFmode:
                  if (pattern464 (x2, 
E_KFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_KFmode) == 0
                      && (
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1783; /* altivec_vselkf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_KFmode) != 0
                      || !(
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 1793; /* altivec_vselkf4 */

                case E_TFmode:
                  if (pattern464 (x2, 
E_TFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern544 (x5, 
E_TFmode) == 0
                      && (
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1784; /* altivec_vseltf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern544 (x5, 
E_TFmode) != 0
                      || !(
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 1794; /* altivec_vseltf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              switch (pattern357 (x2))
                {
                case 0:
                  if (!
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2474; /* *fuse_and_or */

                case 1:
                  if (!(
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2475; /* *fuse_and_or */

                case 2:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2950; /* *fuse_vand_vor */

                case 3:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2951; /* *fuse_vand_vor */

                case 4:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2952; /* *fuse_vand_vor */

                case 5:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2953; /* *fuse_vand_vor */

                case 6:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2954; /* *fuse_vand_vor */

                case 7:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2955; /* *fuse_vand_vor */

                case 8:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2956; /* *fuse_vand_vor */

                case 9:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2957; /* *fuse_vand_vor */

                case 10:
                  if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2958; /* *fuse_vand_vor */

                case 11:
                  if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2959; /* *fuse_vand_vor */

                default:
                  return -1;
                }

            case NOT:
              if (pnum_clobbers == NULL)
                return -1;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              operands[0] = x4;
              operands[1] = x9;
              switch (pattern58 (x2))
                {
                case 0:
                  if (!
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2494; /* *fuse_and_orc */

                case 1:
                  if (!(
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2495; /* *fuse_and_orc */

                case 2:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3030; /* *fuse_vand_vorc */

                case 3:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3031; /* *fuse_vand_vorc */

                case 4:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3032; /* *fuse_vand_vorc */

                case 5:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3033; /* *fuse_vand_vorc */

                case 6:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3034; /* *fuse_vand_vorc */

                case 7:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3035; /* *fuse_vand_vorc */

                case 8:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3036; /* *fuse_vand_vorc */

                case 9:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3037; /* *fuse_vand_vorc */

                case 10:
                  if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3038; /* *fuse_vand_vorc */

                case 11:
                  if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3039; /* *fuse_vand_vorc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_19 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1367; /* xxgenpcvm_v16qi_internal */

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1368; /* xxgenpcvm_v8hi_internal */

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !altivec_register_operand (operands[1], E_V4SImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1369; /* xxgenpcvm_v4si_internal */

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !altivec_register_operand (operands[1], E_V2DImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1370; /* xxgenpcvm_v2di_internal */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !vsx_register_operand (operands[2], E_DFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1245; /* *vsx_tdivdf3_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !vsx_register_operand (operands[2], E_V4SFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1246; /* *vsx_tdivv4sf3_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !vsx_register_operand (operands[2], E_V2DFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1247; /* *vsx_tdivv2df3_internal */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 4510 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2181; /* altivec_vbpermq */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 4520 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2182; /* altivec_vbpermq2 */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!mma_disassemble_output_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (pattern413 ())
    {
    case 0:
      if (!
#line 415 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && vsx_register_operand (operands[1], OOmode)))
        return -1;
      return 2210; /* *vsx_disassemble_pair */

    case 1:
      if (!
#line 489 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[1], XOmode)))
        return -1;
      return 2212; /* *mma_disassemble_acc */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_VOIDmode)
      || !
#line 14137 "../../gcc/config/rs6000/rs6000.md"
(REG_P (operands[0])
   && CR_REGNO_P (REGNO (operands[0]))
   && CONST_INT_P (operands[2])
   && INTVAL (operands[2]) == 1 << (7 - (REGNO (operands[0]) - CR0_REGNO))))
    return -1;
  return 928; /* *mtcrfsi */
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!vsx_register_operand (operands[1], E_DFmode)
              || !
#line 2362 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1313; /* vsx_xscvdpsp */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2400 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1316; /* vsx_xvcvdpsp */

        case E_SFmode:
          if (!vsx_register_operand (operands[1], E_SFmode)
              || !
#line 2446 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1321; /* vsx_xscvdpsp_scalar */

        default:
          return -1;
        }

    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2409 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1317; /* vsx_xscvspdp */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2418 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1318; /* vsx_xscvspdp_scalar2 */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2137; /* altivec_stvehx */

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2138; /* altivec_stvebx */

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 3249 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2139; /* *altivec_stvesfx */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !s32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6587 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1666; /* xxspltiw_v4si */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6607 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1667; /* xxspltiw_v4sf_inst */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !(
#line 2219 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
        return -1;
      return 1943; /* *altivec_v4si_shift_const */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !
#line 2219 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1944; /* *altivec_v2di_shift_const */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1961; /* altivec_vperm_v4si_direct */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1962; /* altivec_vperm_v8hi_direct */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1963; /* altivec_vperm_v16qi_direct */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 2507 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1971; /* altivec_vperm_v8hiv16qi */

        default:
          return -1;
        }

    case E_V4SFmode:
      if (pattern141 (x3, 
E_V4SFmode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1964; /* altivec_vperm_v4sf_direct */

    case E_V2DFmode:
      if (pattern141 (x3, 
E_V2DFmode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1965; /* altivec_vperm_v2df_direct */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1966; /* altivec_vperm_v2di_direct */

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1967; /* altivec_vperm_v1ti_direct */

    case E_TImode:
      if (pattern141 (x3, 
E_TImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1968; /* altivec_vperm_ti_direct */

    case E_KFmode:
      if (pattern141 (x3, 
E_KFmode) != 0
          || !(
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 1969; /* altivec_vperm_kf_direct */

    case E_TFmode:
      if (pattern141 (x3, 
E_TFmode) != 0
          || !(
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 1970; /* altivec_vperm_tf_direct */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (GET_CODE (x2) == SUBREG)
        {
          res = recog_109 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case PC:
          operands[0] = x2;
          if (register_operand (operands[0], E_DImode)
              && (
#line 13533 "../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return 902; /* *indirect_jumpdi */
          break;

        case MEM:
          operands[0] = x3;
          operands[1] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (indexed_or_indirect_operand (operands[0], E_V2DFmode)
                  && vsx_register_operand (operands[1], E_V2DFmode)
                  && 
#line 663 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1159; /* *vsx_le_perm_store_v2df */
              break;

            case E_V2DImode:
              if (indexed_or_indirect_operand (operands[0], E_V2DImode)
                  && vsx_register_operand (operands[1], E_V2DImode)
                  && 
#line 663 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1160; /* *vsx_le_perm_store_v2di */
              break;

            case E_V4SFmode:
              if (indexed_or_indirect_operand (operands[0], E_V4SFmode)
                  && vsx_register_operand (operands[1], E_V4SFmode)
                  && 
#line 733 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1161; /* *vsx_le_perm_store_v4sf */
              break;

            case E_V4SImode:
              if (indexed_or_indirect_operand (operands[0], E_V4SImode)
                  && vsx_register_operand (operands[1], E_V4SImode)
                  && 
#line 733 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1162; /* *vsx_le_perm_store_v4si */
              break;

            case E_V8HImode:
              if (indexed_or_indirect_operand (operands[0], E_V8HImode)
                  && vsx_register_operand (operands[1], E_V8HImode)
                  && 
#line 808 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1163; /* *vsx_le_perm_store_v8hi */
              break;

            case E_V16QImode:
              if (indexed_or_indirect_operand (operands[0], E_V16QImode)
                  && vsx_register_operand (operands[1], E_V16QImode)
                  && 
#line 893 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1164; /* *vsx_le_perm_store_v16qi */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case MEM:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (vsx_register_operand (operands[0], E_V2DFmode)
              && indexed_or_indirect_operand (operands[1], E_V2DFmode)
              && 
#line 449 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1153; /* *vsx_le_perm_load_v2df */
          break;

        case E_V2DImode:
          if (vsx_register_operand (operands[0], E_V2DImode)
              && indexed_or_indirect_operand (operands[1], E_V2DImode)
              && 
#line 449 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1154; /* *vsx_le_perm_load_v2di */
          break;

        case E_V4SFmode:
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && indexed_or_indirect_operand (operands[1], E_V4SFmode)
              && 
#line 497 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1155; /* *vsx_le_perm_load_v4sf */
          break;

        case E_V4SImode:
          if (vsx_register_operand (operands[0], E_V4SImode)
              && indexed_or_indirect_operand (operands[1], E_V4SImode)
              && 
#line 497 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1156; /* *vsx_le_perm_load_v4si */
          break;

        case E_V8HImode:
          if (vsx_register_operand (operands[0], E_V8HImode)
              && indexed_or_indirect_operand (operands[1], E_V8HImode)
              && 
#line 547 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1157; /* *vsx_le_perm_load_v8hi */
          break;

        case E_V16QImode:
          if (vsx_register_operand (operands[0], E_V16QImode)
              && indexed_or_indirect_operand (operands[1], E_V16QImode)
              && 
#line 601 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1158; /* *vsx_le_perm_load_v16qi */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (vsx_register_operand (operands[0], E_KFmode)
          && memory_operand (operands[1], E_KFmode)
          && (
#line 1040 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 1169; /* *vsx_le_perm_load_kf */
      break;

    case E_V1TImode:
      if (vsx_register_operand (operands[0], E_V1TImode)
          && memory_operand (operands[1], E_V1TImode)
          && 
#line 1040 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], V1TImode)))
        return 1172; /* *vsx_le_perm_load_v1ti */
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (memory_operand (operands[0], E_KFmode)
          && vsx_register_operand (operands[1], E_KFmode)
          && (
#line 1063 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 1173; /* *vsx_le_perm_store_kf */
      break;

    case E_V1TImode:
      if (memory_operand (operands[0], E_V1TImode)
          && vsx_register_operand (operands[1], E_V1TImode)
          && 
#line 1063 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
        return 1176; /* *vsx_le_perm_store_v1ti */
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && input_operand (operands[1], E_V16QImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))))
            return 1185; /* vsx_movv16qi_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))))
            return 1195; /* *vsx_movv16qi_32bit */
          if (
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))))
            return 1682; /* *altivec_movv16qi */
        }
      break;

    case E_V4SFmode:
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
            return 1189; /* vsx_movv4sf_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
            return 1199; /* *vsx_movv4sf_32bit */
        }
      break;

    case E_V2DFmode:
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && input_operand (operands[1], E_V2DFmode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))))
            return 1190; /* vsx_movv2df_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))))
            return 1200; /* *vsx_movv2df_32bit */
          if (
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))))
            return 1684; /* *altivec_movv2df */
        }
      break;

    case E_V1TImode:
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && input_operand (operands[1], E_V1TImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))))
            return 1191; /* vsx_movv1ti_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))))
            return 1201; /* *vsx_movv1ti_32bit */
        }
      break;

    case E_KFmode:
      if (nonimmediate_operand (operands[0], E_KFmode)
          && input_operand (operands[1], E_KFmode))
        {
          if ((
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && 
#line 69 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return 1192; /* vsx_movkf_64bit */
          if ((
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && 
#line 69 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return 1202; /* *vsx_movkf_32bit */
          if ((
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return 1687; /* *altivec_movkf */
        }
      break;

    case E_OOmode:
      if (nonimmediate_operand (operands[0], E_OOmode)
          && input_operand (operands[1], E_OOmode)
          && 
#line 298 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], OOmode)
       || gpc_reg_operand (operands[1], OOmode))))
        return 2207; /* *movoo */
      break;

    case E_XOmode:
      if (nonimmediate_operand (operands[0], E_XOmode)
          && input_operand (operands[1], E_XOmode)
          && 
#line 345 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], XOmode)
       || gpc_reg_operand (operands[1], XOmode))))
        return 2208; /* *movxo */
      break;

    default:
      break;
    }
  operands[0] = x2;
  if (GET_CODE (x3) == MEM)
    {
      x4 = XEXP (x3, 0);
      switch (pattern30 (x4))
        {
        case 0:
          switch (pattern485 (x3))
            {
            case 0:
              if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2111; /* altivec_stvx_v16qi_2op_di */
              break;

            case 1:
              if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2113; /* altivec_stvx_v2df_2op_di */
              break;

            case 2:
              if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return 2116; /* altivec_stvx_kf_2op_di */
              break;

            default:
              break;
            }
          break;

        case 1:
          switch (pattern485 (x3))
            {
            case 0:
              if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2120; /* altivec_stvx_v16qi_1op_di */
              break;

            case 1:
              if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2122; /* altivec_stvx_v2df_1op_di */
              break;

            case 2:
              if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return 2125; /* altivec_stvx_kf_1op_di */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case SUBREG:
      res = recog_110 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      x5 = XEXP (x2, 0);
      switch (pattern66 (x5))
        {
        case 0:
          switch (pattern486 (x2))
            {
            case 0:
              if ((
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2084; /* altivec_lvx_v16qi_2op_di */
              break;

            case 1:
              if ((
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2086; /* altivec_lvx_v2df_2op_di */
              break;

            case 2:
              if ((
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return 2089; /* altivec_lvx_kf_2op_di */
              break;

            default:
              break;
            }
          break;

        case 1:
          switch (pattern486 (x2))
            {
            case 0:
              if ((
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2093; /* altivec_lvx_v16qi_1op_di */
              break;

            case 1:
              if ((
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2095; /* altivec_lvx_v2df_1op_di */
              break;

            case 2:
              if ((
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return 2098; /* altivec_lvx_kf_1op_di */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (nonimmediate_operand (operands[0], E_V1TImode))
    {
      operands[1] = x2;
      if (input_operand (operands[1], E_V1TImode)
          && 
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))))
        return 1686; /* *altivec_movv1ti */
    }
  operands[0] = x2;
  switch (pattern31 (x3, 
E_V1TImode))
    {
    case 0:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2115; /* altivec_stvx_v1ti_2op_di */
      break;

    case 1:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2124; /* altivec_stvx_v1ti_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  switch (pattern33 (x1, 
E_V1TImode))
    {
    case 0:
      if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2088; /* altivec_lvx_v1ti_2op_di */

    case 1:
      if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2097; /* altivec_lvx_v1ti_1op_di */

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern8 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_QImode)
                {
                  if (gpc_reg_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 421; /* fixuns_truncsfqi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 425; /* fixuns_truncdfqi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 433; /* *fixuns_truncsfqi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 439; /* *fixuns_truncdfqi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_QImode)
            return -1;
          if (altivec_register_operand (operands[0], E_QImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1034; /* fixuns_trunckfqi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1038; /* fixuns_trunctfqi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern318 (
E_QImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1042; /* *fixuns_trunckfqi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1048; /* *fixuns_trunctfqi2_mem */

            default:
              return -1;
            }

        case E_HImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_HImode)
                {
                  if (gpc_reg_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 423; /* fixuns_truncsfhi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 427; /* fixuns_truncdfhi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 435; /* *fixuns_truncsfhi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 441; /* *fixuns_truncdfhi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_HImode)
            return -1;
          if (altivec_register_operand (operands[0], E_HImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1036; /* fixuns_trunckfhi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1040; /* fixuns_trunctfhi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern318 (
E_HImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1044; /* *fixuns_trunckfhi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1050; /* *fixuns_trunctfhi2_mem */

            default:
              return -1;
            }

        case E_SImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6425 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 429; /* *fixuns_truncsfsi2_p8 */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6425 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 431; /* *fixuns_truncdfsi2_p8 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers != NULL)
            {
              if (memory_operand (operands[0], E_SImode))
                {
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SFmode:
                      if (gpc_reg_operand (operands[1], E_SFmode)
                          && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                        {
                          *pnum_clobbers = 1;
                          return 437; /* *fixuns_truncsfsi2_mem */
                        }
                      break;

                    case E_DFmode:
                      if (gpc_reg_operand (operands[1], E_DFmode)
                          && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                        {
                          *pnum_clobbers = 1;
                          return 443; /* *fixuns_truncdfsi2_mem */
                        }
                      break;

                    default:
                      break;
                    }
                }
              if (nonimmediate_operand (operands[0], E_SImode))
                {
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SFmode:
                      if (gpc_reg_operand (operands[1], E_SFmode)
                          && 
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 444; /* fixuns_truncsfsi2_stfiwx */
                        }
                      break;

                    case E_DFmode:
                      if (gpc_reg_operand (operands[1], E_DFmode)
                          && 
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 445; /* fixuns_truncdfsi2_stfiwx */
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          if (altivec_register_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1026; /* fixuns_kfsi2_hw */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1028; /* fixuns_tfsi2_hw */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern318 (
E_SImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1046; /* *fixuns_trunckfsi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1052; /* *fixuns_trunctfsi2_mem */

            default:
              return -1;
            }

        case E_DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6502 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIDUZ))
                    return 446; /* fixuns_truncsfdi2 */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6502 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIDUZ))
                    return 447; /* fixuns_truncdfdi2 */
                  break;

                default:
                  break;
                }
            }
          if (!altivec_register_operand (operands[0], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1030; /* fixuns_kfdi2_hw */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1032; /* fixuns_tfdi2_hw */

            default:
              return -1;
            }

        case E_TImode:
          if (!vsx_register_operand (operands[0], E_TImode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_TImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (!vsx_register_operand (operands[1], E_KFmode)
                  || !(
#line 6960 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 486; /* fixuns_trunckfti2 */

            case E_TFmode:
              if (!vsx_register_operand (operands[1], E_TFmode)
                  || !(
#line 6960 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 487; /* fixuns_trunctfti2 */

            default:
              return -1;
            }

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V4SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SImode)
              && gpc_reg_operand (operands[1], E_V4SFmode)
              && 
#line 2299 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1296; /* vsx_fixuns_truncv4sfv4si2 */
          if (!vsx_register_operand (operands[0], E_V4SImode)
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 2503 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1331; /* vsx_xvcvspuxws */

        case E_V2DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V2DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DImode)
              && gpc_reg_operand (operands[1], E_V2DFmode)
              && 
#line 2299 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1297; /* vsx_fixuns_truncv2dfv2di2 */
          if (!vsx_register_operand (operands[0], E_V2DImode)
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2510 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1333; /* vsx_xvcvdpuxds */

        default:
          return -1;
        }

    case 1:
      if (!
#line 2680 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
        return -1;
      return 1345; /* vsx_xvcvspuxds_be */

    case 2:
      if (!
#line 2689 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
        return -1;
      return 1347; /* vsx_xvcvspuxds_le */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 16L:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 0);
          if (!gpc_reg_operand (x6, E_SImode))
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              operands[2] = x6;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1571 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 53; /* *mulchw */

            case ASHIFTRT:
              x9 = XEXP (x7, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              operands[1] = x6;
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1632 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 57; /* *mulhhw */

            default:
              return -1;
            }

        case 32L:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != ASHIFTRT)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          switch (pattern285 (x3))
            {
            case 0:
              if (!
#line 6556 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1661; /* smulv2di3_highpart */

            case 1:
              if (!
#line 6556 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1662; /* smulv4si3_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (!gpc_reg_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      switch (GET_CODE (x7))
        {
        case ZERO_EXTEND:
          operands[2] = x6;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_HImode)
              || !
#line 1600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 55; /* *mulchwu */

        case LSHIFTRT:
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          operands[1] = x6;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 1664 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 59; /* *mulhhwu */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern43 (x3, 
SIGN_EXTEND) != 0
          || !
#line 1690 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 61; /* *mullhw */

    case ZERO_EXTEND:
      if (pattern43 (x3, 
ZERO_EXTEND) != 0
          || !
#line 1716 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 63; /* *mullhwu */

    case REG:
    case SUBREG:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern260 (x3, 
E_SImode) != 0)
            return -1;
          return 154; /* mulsi3 */

        case E_DImode:
          if (pattern260 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 155; /* muldi3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 305; /* *mulsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 306; /* *muldf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15040 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 991; /* mulkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15040 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 992; /* multf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1718 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1232; /* *vsx_mulv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1718 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1233; /* *vsx_mulv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6577 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1665; /* mulv2di3 */

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0
              || !
#line 803 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1796; /* mulv4si3_p8 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 193 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2291; /* muldd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 193 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2292; /* multd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  res = recog_26 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_CODE (x2))
    {
    case NE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 870; /* *nesi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 874; /* *nedi_cc */

        default:
          return -1;
        }

    case LE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 878; /* *lesi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 884; /* *ledi_cc */

        default:
          return -1;
        }

    case LEU:
      switch (pattern126 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 825; /* leusisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 845; /* leusidi2_isel */

        case 2:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 835; /* leudisi2_isel */

        case 3:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 855; /* leudidi2_isel */

        default:
          return -1;
        }

    case GE:
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      res = recog_29 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      switch (pattern9 (x2))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 879; /* *gesi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 885; /* *gedi_cc */

        default:
          return -1;
        }

    case GEU:
      switch (pattern126 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 827; /* geusisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 847; /* geusidi2_isel */

        case 2:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 837; /* geudisi2_isel */

        case 3:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 857; /* geudidi2_isel */

        default:
          return -1;
        }

    case ORDERED:
      switch (pattern12 (x2))
        {
        case 0:
          if (!
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 869; /* *orderedsi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 873; /* *ordereddi_cc */

        case 2:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1147; /* vector_orderedv4sf */

        case 3:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1151; /* vector_orderedv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  x10 = XEXP (x5, 0);
  operands[0] = x10;
  x11 = XEXP (x6, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x6, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[3], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern543 (x6, 
E_SImode) != 0
              || !(
#line 10241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 690; /* *movdi_update1 */

        case E_DImode:
          if (pattern543 (x6, 
E_DImode) != 0
              || !(
#line 10241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 691; /* *movdi_update1 */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern531 (x1, 
E_SImode))
        {
        case 0:
          if (!(
#line 10291 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 695; /* *movsi_update1 */

        case 1:
          if (!(
#line 10291 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 696; /* *movsi_update1 */

        default:
          return -1;
        }

    case E_HImode:
      switch (pattern531 (x1, 
E_HImode))
        {
        case 0:
          if (!(
#line 10355 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], SImode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 701; /* *movhi_update1 */

        case 1:
          if (!(
#line 10355 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], SImode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 702; /* *movhi_update1 */

        default:
          return -1;
        }

    case E_QImode:
      switch (pattern531 (x1, 
E_QImode))
        {
        case 0:
          if (!(
#line 10422 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 713; /* *movqi_update1 */

        case 1:
          if (!(
#line 10422 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 714; /* *movqi_update1 */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern531 (x1, 
E_SFmode))
        {
        case 0:
          if ((
#line 10471 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return 721; /* *movsf_update1 */
          if (!(
#line 10505 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 729; /* *movsf_update3 */

        case 1:
          if ((
#line 10471 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return 722; /* *movsf_update1 */
          if (!(
#line 10505 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 730; /* *movsf_update3 */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern531 (x1, 
E_DFmode))
        {
        case 0:
          if (!(
#line 10471 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 723; /* *movdf_update1 */

        case 1:
          if (!(
#line 10471 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 724; /* *movdf_update1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_152 (x1, insn, pnum_clobbers);

    case 1:
      return recog_151 (x1, insn, pnum_clobbers);

    case 3:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (XINT (x3, 1))
        {
        case 123:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || !gpc_reg_operand (operands[0], E_V4SFmode))
            return -1;
          switch (pattern448 (x1))
            {
            case 0:
              if (!
#line 4616 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1497; /* vsx_set_v4sf_p9 */

            case 1:
              if (!
#line 4652 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1498; /* *vsx_set_v4sf_p9_zero */

            case 2:
              if (!
#line 4712 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
                return -1;
              return 1500; /* *vsx_insert_extract_v4sf_p9_2 */

            default:
              return -1;
            }

        case 214:
          if (pattern332 (x1, 
E_V4SImode) != 0
              || !
#line 1052 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1822; /* altivec_vmsumuhs */

        case 215:
          if (pattern332 (x1, 
E_V4SImode) != 0
              || !
#line 1063 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1823; /* altivec_vmsumshs */

        case 216:
          if (pattern332 (x1, 
E_V8HImode) != 0
              || !
#line 1124 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1842; /* altivec_vmhaddshs */

        case 217:
          if (pattern332 (x1, 
E_V8HImode) != 0
              || !
#line 1135 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1843; /* altivec_vmhraddshs */

        case 342:
          switch (pattern334 (x1, 
342))
            {
            case 0:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2184; /* bcdadd_v1ti */

            case 1:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2186; /* bcdadd_v16qi */

            case 2:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2192; /* *bcdadd_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2194; /* *bcdadd_test2_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern334 (x1, 
343))
            {
            case 0:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2185; /* bcdsub_v1ti */

            case 1:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2187; /* bcdsub_v16qi */

            case 2:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2193; /* *bcdsub_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2195; /* *bcdsub_test2_v16qi */

            default:
              return -1;
            }

        case 345:
          if (GET_MODE (x3) != E_V16QImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern331 (x6, 
E_CCFPmode, 
106, 
CLOBBER) != 0
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode)
              || !
#line 4763 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2206; /* bcdshift_v16qi */

        case 445:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern517 (x3, 
E_QImode) != 0
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3195; /* *pcrel_opt_ldqi_gpr */

            case E_HImode:
              if (pattern517 (x3, 
E_HImode) != 0
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3196; /* *pcrel_opt_ldhi_gpr */

            case E_SImode:
              if (pattern517 (x3, 
E_SImode) != 0
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3197; /* *pcrel_opt_ldsi_gpr */

            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || !d_form_memory (operands[1], E_DImode))
                return -1;
              if (int_reg_operand (operands[0], E_DImode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3198; /* *pcrel_opt_lddi_gpr */
              if (!vsx_register_operand (operands[0], E_DImode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3209; /* *pcrel_opt_lddi_vsx */

            case E_SFmode:
              if (GET_MODE (x3) != E_SFmode
                  || !d_form_memory (operands[1], E_SFmode))
                return -1;
              if (int_reg_operand (operands[0], E_SFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3199; /* *pcrel_opt_ldsf_gpr */
              if (!vsx_register_operand (operands[0], E_SFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3211; /* *pcrel_opt_ldsf_vsx */

            case E_DFmode:
              if (GET_MODE (x3) != E_DFmode
                  || !d_form_memory (operands[1], E_DFmode))
                return -1;
              if (int_reg_operand (operands[0], E_DFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3200; /* *pcrel_opt_lddf_gpr */
              if (!vsx_register_operand (operands[0], E_DFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3210; /* *pcrel_opt_lddf_vsx */

            case E_TImode:
              if (pattern518 (x3, 
E_TImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3213; /* *pcrel_opt_ldti */

            case E_KFmode:
              if (pattern518 (x3, 
E_KFmode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3214; /* *pcrel_opt_ldkf */

            case E_V1TImode:
              if (pattern518 (x3, 
E_V1TImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3215; /* *pcrel_opt_ldv1ti */

            case E_V2DImode:
              if (pattern518 (x3, 
E_V2DImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3216; /* *pcrel_opt_ldv2di */

            case E_V4SImode:
              if (pattern518 (x3, 
E_V4SImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3217; /* *pcrel_opt_ldv4si */

            case E_V8HImode:
              if (pattern518 (x3, 
E_V8HImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3218; /* *pcrel_opt_ldv8hi */

            case E_V16QImode:
              if (pattern518 (x3, 
E_V16QImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3219; /* *pcrel_opt_ldv16qi */

            case E_V2DFmode:
              if (pattern518 (x3, 
E_V2DFmode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3220; /* *pcrel_opt_ldv2df */

            case E_V4SFmode:
              if (pattern518 (x3, 
E_V4SFmode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3221; /* *pcrel_opt_ldv4sf */

            case E_TFmode:
              if (pattern518 (x3, 
E_TFmode) != 0
                  || !(
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 99 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
                return -1;
              return 3222; /* *pcrel_opt_ldtf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      res = recog_154 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98
          || pattern287 (x1, 
-1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern494 (x1, 
E_SImode) != 0)
            return -1;
          return 113; /* subfsi3_carry_in_xx */

        case E_DImode:
          if (pattern494 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 114; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          res = recog_155 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[0] = x6;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              res = recog_156 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x6;
          if (pattern288 (x1) == 0)
            {
              x7 = XEXP (x3, 1);
              switch (GET_CODE (x7))
                {
                case REG:
                case SUBREG:
                  operands[2] = x7;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern536 (x1, 
E_SImode) == 0)
                        return 82; /* *addsi3_carry_in_internal2 */
                      break;

                    case E_DImode:
                      if (pattern536 (x1, 
E_DImode) == 0
                          && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                        return 83; /* *adddi3_carry_in_internal2 */
                      break;

                    default:
                      break;
                    }
                  break;

                case CONST_INT:
                  if (XWINT (x7, 0) == -1L)
                    {
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern537 (x1, 
E_SImode) == 0)
                            return 86; /* addsi3_carry_in_m1 */
                          break;

                        case E_DImode:
                          if (pattern537 (x1, 
E_DImode) == 0
                              && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                            return 87; /* adddi3_carry_in_m1 */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x6;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          switch (pattern247 (x1))
            {
            case 0:
              if (!
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3190; /* *fuse_add_add */

            case 1:
              if (!(
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 3191; /* *fuse_add_add */

            default:
              return -1;
            }

        case NOT:
          if (pattern288 (x1) != 0)
            return -1;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern527 (x1, 
E_SImode) != 0)
                return -1;
              return 107; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern527 (x1, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 108; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern495 (x1, 
E_SImode) != 0)
            return -1;
          return 109; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern495 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 110; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98
          || pattern287 (x1, 
-2) != 0)
        return -1;
      x11 = XEXP (x4, 1);
      operands[1] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern519 (x1, 
E_SImode) != 0)
            return -1;
          return 111; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern519 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 112; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (GET_MODE (x4) != E_V2DFmode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x12 = XEXP (x6, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT
          || GET_MODE (x11) != E_DFmode)
        return -1;
      x14 = XEXP (x11, 1);
      if (GET_CODE (x14) != PARALLEL
          || XVECLEN (x14, 0) != 1)
        return -1;
      x15 = XVECEXP (x14, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!vfloat_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || pattern79 (x1) != 0
          || !
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1526; /* vsx_reduc_plus_v2df */

    case AND:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2526; /* *fuse_and_add */

        case 1:
          if (!(
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2527; /* *fuse_and_add */

        case 2:
          if (!
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2530; /* *fuse_nor_add */

        case 3:
          if (!(
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2531; /* *fuse_nor_add */

        default:
          return -1;
        }

    case IOR:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2528; /* *fuse_nand_add */

        case 1:
          if (!(
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2529; /* *fuse_nand_add */

        case 2:
          if (!
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2532; /* *fuse_or_add */

        case 3:
          if (!(
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2533; /* *fuse_or_add */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern78 (x1))
    {
    case 0:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern455 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 421; /* fixuns_truncsfqi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 425; /* fixuns_truncdfqi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      switch (pattern457 (
E_QImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 433; /* *fixuns_truncsfqi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 439; /* *fixuns_truncdfqi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1042; /* *fixuns_trunckfqi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1048; /* *fixuns_trunctfqi2_mem */

        default:
          return -1;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern455 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 423; /* fixuns_truncsfhi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 427; /* fixuns_truncdfhi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      switch (pattern457 (
E_HImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 435; /* *fixuns_truncsfhi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 441; /* *fixuns_truncdfhi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1044; /* *fixuns_trunckfhi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1050; /* *fixuns_trunctfhi2_mem */

        default:
          return -1;
        }

    case 2:
      if (memory_operand (operands[0], E_SImode))
        {
          switch (pattern456 ())
            {
            case 0:
              if (
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                return 437; /* *fixuns_truncsfsi2_mem */
              break;

            case 1:
              if (
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                return 443; /* *fixuns_truncdfsi2_mem */
              break;

            case 2:
              if ((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 1046; /* *fixuns_trunckfsi2_mem */
              break;

            case 3:
              if ((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 1052; /* *fixuns_trunctfsi2_mem */
              break;

            default:
              break;
            }
        }
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      switch (pattern455 (
E_DImode))
        {
        case 0:
          if (!
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 444; /* fixuns_truncsfsi2_stfiwx */

        case 1:
          if (!
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 445; /* fixuns_truncdfsi2_stfiwx */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case UNSIGNED_FLOAT:
          if (pattern190 (x1, 
USE, 
E_DFmode) != 0
              || pattern392 (x1) != 0
              || !
#line 6170 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)))
            return -1;
          return 405; /* *floatunssidf2_internal */

        case FIX:
          if (pattern190 (x1, 
CLOBBER, 
E_SImode) != 0)
            return -1;
          switch (pattern393 (x1))
            {
            case 0:
              if (!(
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 610; /* *fix_truncifsi2_internal */

            case 1:
              if (!(
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return -1;
              return 611; /* *fix_trunctfsi2_internal */

            default:
              return -1;
            }

        case CALL:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode
              || pattern254 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!indirect_call_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!unspec_tls (operands[2], E_DImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          if (!immediate_operand (operands[3], E_SImode))
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          if (!memory_operand (operands[4], E_DImode))
            return -1;
          x13 = XVECEXP (x1, 0, 3);
          x14 = XEXP (x13, 1);
          x15 = XVECEXP (x14, 0, 0);
          operands[5] = x15;
          if (!const_int_operand (operands[5], E_DImode)
              || !(
#line 11749 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 786; /* *call_value_indirect_aixdi */

        case IF_THEN_ELSE:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != AND)
            return -1;
          x16 = XEXP (x5, 1);
          if (!branch_comparison_operator (x16, E_VOIDmode))
            return -1;
          operands[3] = x16;
          x17 = XEXP (x16, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern114 (x1) != 0)
            return -1;
          x18 = XEXP (x16, 0);
          operands[4] = x18;
          if (!cc_reg_operand (operands[4], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          x19 = XEXP (x8, 0);
          operands[0] = x19;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          if (!nonimmediate_operand (operands[2], E_DImode))
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[5] = x12;
          if (!scratch_operand (operands[5], E_DImode))
            return -1;
          x13 = XVECEXP (x1, 0, 3);
          x20 = XEXP (x13, 0);
          operands[6] = x20;
          if (!scratch_operand (operands[6], E_CCmode))
            return -1;
          x21 = XEXP (x2, 0);
          operands[7] = x21;
          if (!scratch_operand (operands[7], E_CCEQmode))
            return -1;
          switch (pattern555 (x1))
            {
            case 0:
              return 911; /* bdztf_di */

            case 1:
              return 912; /* bdnztf_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode
          || pattern254 (x1) != 0)
        return -1;
      x22 = XEXP (x6, 0);
      operands[0] = x22;
      if (!indirect_call_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 1);
      operands[1] = x4;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      operands[3] = x12;
      if (!memory_operand (operands[3], E_DImode))
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XVECEXP (x14, 0, 0);
      operands[4] = x15;
      if (!const_int_operand (operands[4], E_DImode)
          || !(
#line 11728 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 785; /* *call_indirect_aixdi */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      switch (XINT (x5, 1))
        {
        case 87:
          if (GET_MODE (x5) != E_SImode
              || !nonimmediate_operand (operands[0], E_SImode))
            return NULL;
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          if (!input_operand (operands[1], E_SFmode)
              || !scratch_operand (operands[2], E_V4SFmode)
              || !(
#line 7832 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))) && 
#line 7847 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && int_reg_operand (operands[0], SImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))))
            return NULL;
          return gen_split_291 (insn, operands);

        case 86:
          if (GET_MODE (x5) != E_SFmode
              || !scratch_operand (operands[2], E_DImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_SFmode))
            {
              x7 = XVECEXP (x5, 0, 0);
              operands[1] = x7;
              if (input_operand (operands[1], E_SImode)
                  && (
#line 8385 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))) && 
#line 8400 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && vsx_reg_sfsubreg_ok (operands[0], SFmode)
   && int_reg_operand_not_pseudo (operands[1], SImode))))
                return gen_split_301 (insn, operands);
            }
          x7 = XVECEXP (x5, 0, 0);
          if (!lowpart_subreg_operator (x7, E_SImode))
            return NULL;
          switch (pattern470 (x7))
            {
            case 0:
              if (!(
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG) && 
#line 8454 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_302 (insn, operands);

            case 1:
              if (!(
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG) && 
#line 8454 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_303 (insn, operands);

            default:
              return NULL;
            }

        case 61:
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern446 (x5, 
E_DImode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_341 (insn, operands);

            case E_DFmode:
              if (pattern446 (x5, 
E_DFmode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_342 (insn, operands);

            case E_DDmode:
              if (pattern446 (x5, 
E_DDmode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_343 (insn, operands);

            case E_TImode:
              if (pattern446 (x5, 
E_TImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_344 (insn, operands);

            case E_V16QImode:
              if (pattern446 (x5, 
E_V16QImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_345 (insn, operands);

            case E_V8HImode:
              if (pattern446 (x5, 
E_V8HImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_346 (insn, operands);

            case E_V4SImode:
              if (pattern446 (x5, 
E_V4SImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_347 (insn, operands);

            case E_V4SFmode:
              if (pattern446 (x5, 
E_V4SFmode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_348 (insn, operands);

            case E_V2DImode:
              if (pattern446 (x5, 
E_V2DImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_349 (insn, operands);

            case E_V2DFmode:
              if (pattern446 (x5, 
E_V2DFmode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_350 (insn, operands);

            case E_V1TImode:
              if (pattern446 (x5, 
E_V1TImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_351 (insn, operands);

            case E_KFmode:
              if (pattern446 (x5, 
E_KFmode, 
E_IFmode) != 0
                  || !((
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_352 (insn, operands);

            case E_TFmode:
              if (pattern446 (x5, 
E_TFmode, 
E_IFmode) != 0
                  || !((
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case E_SFmode:
              if (pattern446 (x5, 
E_SFmode, 
E_DImode) != 0
                  || !(
#line 9688 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9690 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_364 (insn, operands);

            default:
              return NULL;
            }

        case 64:
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern447 (x5, 
E_TImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_365 (insn, operands);

            case E_V16QImode:
              if (pattern447 (x5, 
E_V16QImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_366 (insn, operands);

            case E_V8HImode:
              if (pattern447 (x5, 
E_V8HImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_367 (insn, operands);

            case E_V4SImode:
              if (pattern447 (x5, 
E_V4SImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_368 (insn, operands);

            case E_V4SFmode:
              if (pattern446 (x5, 
E_V4SFmode, 
E_V4SFmode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_369 (insn, operands);

            case E_V2DImode:
              if (pattern447 (x5, 
E_V2DImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_370 (insn, operands);

            case E_V2DFmode:
              if (pattern447 (x5, 
E_V2DFmode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_371 (insn, operands);

            case E_V1TImode:
              if (pattern447 (x5, 
E_V1TImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_372 (insn, operands);

            case E_KFmode:
              if (pattern447 (x5, 
E_KFmode) != 0
                  || !((
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_373 (insn, operands);

            case E_TFmode:
              if (pattern447 (x5, 
E_TFmode) != 0
                  || !((
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_374 (insn, operands);

            case E_SFmode:
              if (pattern446 (x5, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 9752 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9754 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_375 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      if (XINT (x5, 1) != 145)
        return NULL;
      switch (pattern330 (x1))
        {
        case 0:
          if (!(
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3677 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_594 (insn, operands);

        case 1:
          if (!(
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3677 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_595 (insn, operands);

        case 2:
          if (!(
#line 3762 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3764 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_599 (insn, operands);

        case 3:
          if (!(
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_618 (insn, operands);

        case 4:
          if (!(
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_619 (insn, operands);

        case 5:
          if (!(
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_620 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      if (XINT (x5, 1) != 123
          || GET_MODE (x5) != E_V4SFmode
          || !gpc_reg_operand (operands[0], E_V4SFmode))
        return NULL;
      x7 = XVECEXP (x5, 0, 0);
      operands[1] = x7;
      switch (pattern448 (x1))
        {
        case 0:
          if (!(
#line 4616 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 4618 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_655 (insn, operands);

        case 1:
          if (!(
#line 4652 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 4654 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_656 (insn, operands);

        case 2:
          if (!(
#line 4712 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))) && 
#line 4716 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_657 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern257 (x2))
        {
        case 0:
          return gen_split_85 (insn, operands);

        case 1:
          if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return NULL;
          return gen_split_87 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (!const_int_operand (x5, E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern196 (x2, 
E_SImode) != 0
                  || !
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                return NULL;
              return gen_split_110 (insn, operands);

            case E_DImode:
              if (pattern196 (x2, 
E_DImode) != 0
                  || !(
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_113 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          operands[3] = x5;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern522 (x2, 
E_SImode) != 0
                  || !
#line 4422 "../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (SImode)))
                return NULL;
              return gen_split_115 (insn, operands);

            case E_DImode:
              if (pattern522 (x2, 
E_DImode) != 0
                  || !(
#line 4422 "../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_116 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          operands[2] = x5;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern411 (x2, 
E_DImode) != 0)
                return NULL;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  if (!memory_operand (operands[3], E_QImode)
                      || !
#line 4504 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 8))
                    return NULL;
                  return gen_split_121 (insn, operands);

                case E_HImode:
                  if (!memory_operand (operands[3], E_HImode)
                      || !
#line 4504 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 16))
                    return NULL;
                  return gen_split_122 (insn, operands);

                case E_SImode:
                  if (!memory_operand (operands[3], E_SImode)
                      || !
#line 4504 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 32))
                    return NULL;
                  return gen_split_123 (insn, operands);

                default:
                  return NULL;
                }

            case E_SImode:
              if (pattern411 (x2, 
E_SImode) != 0)
                return NULL;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  if (!memory_operand (operands[3], E_QImode)
                      || !
#line 4549 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 8))
                    return NULL;
                  return gen_split_127 (insn, operands);

                case E_HImode:
                  if (!memory_operand (operands[3], E_HImode)
                      || !
#line 4549 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 16))
                    return NULL;
                  return gen_split_128 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != ASHIFT)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return NULL;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern523 (x2, 
E_SImode) != 0
              || !
#line 4446 "../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (SImode)))
            return NULL;
          return gen_split_117 (insn, operands);

        case E_DImode:
          if (pattern523 (x2, 
E_DImode) != 0
              || !(
#line 4446 "../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          return gen_split_118 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_prefixed_constant (operands[1], E_SFmode)
          && 
#line 8750 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
        return gen_split_310 (insn, operands);
      break;

    case E_DFmode:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_prefixed_constant (operands[1], E_DFmode)
          && 
#line 8750 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
        return gen_split_311 (insn, operands);
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if (((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TFmode)
   && (TFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))) && 
#line 8812 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_312 (insn, operands);
          if (((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TFmode)
       || int_reg_operand_not_pseudo (operands[0], TFmode)
       || int_reg_operand_not_pseudo (operands[1], TFmode))
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))) && 
#line 8850 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_316 (insn, operands);
          if (((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 8865 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_319 (insn, operands);
          if ((
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], TFmode)
       || int_reg_operand (operands[1], TFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TFmode)
           && !vsx_register_operand (operands[1], TFmode)))) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_363 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_525 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_TFmode)
          && memory_operand (operands[1], E_TFmode)
          && (
#line 1045 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_570 (insn, operands);
      if (memory_operand (operands[0], E_TFmode)
          && vsx_register_operand (operands[1], E_TFmode))
        {
          if ((
#line 1075 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_574 (insn, operands);
          if ((
#line 1131 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_578 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_TFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_TFmode)
          && (
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && reload_completed) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_683 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_TFmode)
          && (
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && reload_completed) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_693 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_TFmode)
          || !(
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return NULL;
      return gen_split_703 (insn, operands);

    case E_IFmode:
      if (!nonimmediate_operand (operands[0], E_IFmode)
          || !input_operand (operands[1], E_IFmode))
        return NULL;
      if (((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (IFmode)
   && (IFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 8812 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_313 (insn, operands);
      if (((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (IFmode)
       || int_reg_operand_not_pseudo (operands[0], IFmode)
       || int_reg_operand_not_pseudo (operands[1], IFmode))
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 8850 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_317 (insn, operands);
      if (!((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8865 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_320 (insn, operands);

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !input_operand (operands[1], E_TDmode))
        return NULL;
      if (((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TDmode)
   && (TDmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8812 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_314 (insn, operands);
      if ((
#line 8826 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && !WORDS_BIG_ENDIAN
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 8830 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_315 (insn, operands);
      if (((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TDmode)
       || int_reg_operand_not_pseudo (operands[0], TDmode)
       || int_reg_operand_not_pseudo (operands[1], TDmode))
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8850 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_318 (insn, operands);
      if (!((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8865 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_321 (insn, operands);

    case E_TImode:
      return split_12 (x1, insn);

    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && input_operand (operands[1], E_V16QImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V16QImode)
       || int_reg_operand (operands[1], V16QImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V16QImode)
           && !vsx_register_operand (operands[1], V16QImode)))))
            return gen_split_355 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_516 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V16QImode)
          && indexed_or_indirect_operand (operands[1], E_V16QImode)
          && (
#line 601 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 603 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_554 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V16QImode)
          && vsx_register_operand (operands[1], E_V16QImode))
        {
          if (
#line 901 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_565 (insn, operands);
          if (
#line 959 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_566 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V16QImode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V16QImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && reload_completed))
        return gen_split_676 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V16QImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && reload_completed))
        return gen_split_686 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V16QImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_696 (insn, operands);

    case E_V8HImode:
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && input_operand (operands[1], E_V8HImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V8HImode)
       || int_reg_operand (operands[1], V8HImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V8HImode)
           && !vsx_register_operand (operands[1], V8HImode)))))
            return gen_split_356 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_517 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V8HImode)
          && indexed_or_indirect_operand (operands[1], E_V8HImode)
          && (
#line 547 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 549 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_553 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V8HImode)
          || !vsx_register_operand (operands[1], E_V8HImode))
        return NULL;
      if (
#line 816 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_563 (insn, operands);
      if (!
#line 866 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_564 (insn, operands);

    case E_V4SImode:
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && input_operand (operands[1], E_V4SImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V4SImode)
       || int_reg_operand (operands[1], V4SImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SImode)
           && !vsx_register_operand (operands[1], V4SImode)))))
            return gen_split_357 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_518 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V4SImode)
          && indexed_or_indirect_operand (operands[1], E_V4SImode)
          && (
#line 497 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 499 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_552 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V4SImode)
          || !vsx_register_operand (operands[1], E_V4SImode))
        return NULL;
      if (
#line 741 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_560 (insn, operands);
      if (!
#line 787 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_562 (insn, operands);

    case E_V4SFmode:
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V4SFmode)
       || int_reg_operand (operands[1], V4SFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SFmode)
           && !vsx_register_operand (operands[1], V4SFmode)))))
            return gen_split_358 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_520 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && indexed_or_indirect_operand (operands[1], E_V4SFmode)
          && (
#line 497 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 499 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_551 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode))
        {
          if (
#line 741 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_559 (insn, operands);
          if (
#line 787 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_561 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V4SFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V4SFmode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && reload_completed))
        return gen_split_677 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V4SFmode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && reload_completed))
        return gen_split_687 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V4SFmode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_697 (insn, operands);

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && input_operand (operands[1], E_V2DImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V2DImode)
       || int_reg_operand (operands[1], V2DImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DImode)
           && !vsx_register_operand (operands[1], V2DImode)))))
            return gen_split_359 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_519 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V2DImode)
          && indexed_or_indirect_operand (operands[1], E_V2DImode)
          && (
#line 449 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 451 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_550 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V2DImode)
          || !vsx_register_operand (operands[1], E_V2DImode))
        return NULL;
      if (
#line 671 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_556 (insn, operands);
      if (!
#line 715 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_558 (insn, operands);

    case E_V2DFmode:
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && input_operand (operands[1], E_V2DFmode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V2DFmode)
       || int_reg_operand (operands[1], V2DFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DFmode)
           && !vsx_register_operand (operands[1], V2DFmode)))))
            return gen_split_360 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_521 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V2DFmode)
          && indexed_or_indirect_operand (operands[1], E_V2DFmode)
          && (
#line 449 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 451 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_549 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V2DFmode)
          && vsx_register_operand (operands[1], E_V2DFmode))
        {
          if (
#line 671 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_555 (insn, operands);
          if (
#line 715 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_557 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V2DFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V2DFmode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && reload_completed))
        return gen_split_678 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V2DFmode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && reload_completed))
        return gen_split_688 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V2DFmode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_698 (insn, operands);

    case E_V1TImode:
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && input_operand (operands[1], E_V1TImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V1TImode)
       || int_reg_operand (operands[1], V1TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V1TImode)
           && !vsx_register_operand (operands[1], V1TImode)))))
            return gen_split_361 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_522 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V1TImode)
          && memory_operand (operands[1], E_V1TImode)
          && 
#line 1045 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], V1TImode)))
        return gen_split_572 (insn, operands);
      if (memory_operand (operands[0], E_V1TImode)
          && vsx_register_operand (operands[1], E_V1TImode))
        {
          if (
#line 1075 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
            return gen_split_576 (insn, operands);
          if (
#line 1131 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
            return gen_split_580 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V1TImode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V1TImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && reload_completed))
        return gen_split_680 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V1TImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && reload_completed))
        return gen_split_690 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V1TImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_700 (insn, operands);

    case E_KFmode:
      if (nonimmediate_operand (operands[0], E_KFmode)
          && input_operand (operands[1], E_KFmode))
        {
          if ((
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], KFmode)
       || int_reg_operand (operands[1], KFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], KFmode)
           && !vsx_register_operand (operands[1], KFmode)))) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_362 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_524 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_KFmode)
          && memory_operand (operands[1], E_KFmode)
          && (
#line 1045 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_569 (insn, operands);
      if (memory_operand (operands[0], E_KFmode)
          && vsx_register_operand (operands[1], E_KFmode))
        {
          if ((
#line 1075 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_573 (insn, operands);
          if ((
#line 1131 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_577 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_KFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_KFmode)
          && (
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && reload_completed) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_682 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_KFmode)
          && (
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && reload_completed) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_692 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_KFmode)
          || !(
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return NULL;
      return gen_split_702 (insn, operands);

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && input_operand (operands[1], E_DImode)
          && 
#line 9856 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return gen_split_377 (insn, operands);
      if (int_reg_operand (operands[0], E_DImode)
          && const_int_operand (operands[1], E_DImode))
        {
          if (
#line 9957 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && num_insns_constant (operands[1], DImode) > 1
   && !IN_RANGE (INTVAL (operands[1]), -0x80000000, 0xffffffff)
   && rs6000_is_valid_and_mask (operands[1], DImode)))
            return gen_split_380 (insn, operands);
          if (
#line 9975 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[1], DImode) > 1))
            return gen_split_381 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_DImode)
          || !s5bit_cint_operand (operands[1], E_DImode)
          || !
#line 9987 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && reload_completed))
        return NULL;
      return gen_split_382 (insn, operands);

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !input_operand (operands[1], E_DFmode)
          || !
#line 9856 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_378 (insn, operands);

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !input_operand (operands[1], E_DDmode)
          || !
#line 9856 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_379 (insn, operands);

    case E_PTImode:
      if (!nonimmediate_operand (operands[0], E_PTImode)
          || !input_operand (operands[1], E_PTImode)
          || !
#line 10090 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return NULL;
      return gen_split_390 (insn, operands);

    case E_OOmode:
      if (!nonimmediate_operand (operands[0], E_OOmode)
          || !input_operand (operands[1], E_OOmode)
          || !(
#line 298 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], OOmode)
       || gpc_reg_operand (operands[1], OOmode))) && 
#line 305 "../../gcc/config/rs6000/mma.md"
( reload_completed
   && (!MEM_P (operands[0]) && !MEM_P (operands[1])))))
        return NULL;
      return gen_split_720 (insn, operands);

    case E_XOmode:
      if (!nonimmediate_operand (operands[0], E_XOmode)
          || !input_operand (operands[1], E_XOmode)
          || !(
#line 345 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], XOmode)
       || gpc_reg_operand (operands[1], XOmode))) && 
#line 352 "../../gcc/config/rs6000/mma.md"
( reload_completed)))
        return NULL;
      return gen_split_721 (insn, operands);

    default:
      return NULL;
    }
}
